/* client.c */
/* Copyright (C) 1995 Eric Young (eay@mincom.oz.au).
 * All rights reserved.
 * Copyright remains Eric Young's, and as such any Copyright notices in
 * the code are not to be removed.
 * See the COPYRIGHT file in the SSLeay distribution for more details.
 */

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <netinet/in.h>
#include "net.h"
#include "X509.h"
#include "ssl.h"

/*#define SSL_X509_NAME	"www.netscape.com" /**/
/*#define SSL_X509_NAME	"193.118.187.102" /**/
#define SSL_X509_NAME	"localhost" /**/

#define TEST_CERT "test.PEM"

#define BUFSIZZ	100*1024

main(argc,argv)
int argc;
char *argv[];
	{
	SSL *con,*con2;
	int s,i,width;
	char buf[BUFSIZZ];
	fd_set readfds;
	int port=PORT;

        if (argc>1)
            port=atoi(argv[1]);

	if (!X509_set_default_verify_paths()) exit(1);

        SSL_debug("client.log");
	if (init_client(SSL_X509_NAME,&s,SERVICE,port) == 0)
		{ perror("conecting"); exit(1); }
	fprintf(stderr,"CONNECTED\n");

	con=(SSL *)SSL_new();
	SSL_set_fd(con,s);
	SSL_set_verify(con,SSL_VERIFY_NONE,NULL);

	SSL_set_pref_cipher(con,getenv("SSL_CIPHER"));
	SSL_use_certificate_file(con,TEST_CERT,X509_FILETYPE_PEM);
	SSL_use_RSAPrivateKey_file(con,TEST_CERT,X509_FILETYPE_PEM);

	if (!SSL_connect(con))
		{
		fprintf(stderr,"SSL error\n");
		fprintf(stderr,"function is:%s\n",
			SSL_error_func_string(SSL_errno));
		fprintf(stderr,"error is   :%s\n",
			SSL_error_string(SSL_errno));
		close(s);
		exit(1);
		}

	SSL_write(con,"bye\n",4);
	close(s); 

	if (init_client(SSL_X509_NAME,&s,SERVICE,port) == 0)
		{ perror("conecting"); exit(1); }
	con2=SSL_new();
	SSL_use_certificate_file(con,"eay.bin",X509_FILETYPE_DER);
	SSL_use_RSAPrivateKey_file(con,"eay.private.bin",X509_FILETYPE_DER);
	SSL_set_fd(con2,s);
	SSL_copy_session_id(con2,con);
	if (!SSL_connect(con2))
		{
		fprintf(stderr,"SSL error\n");
		fprintf(stderr,"function is:%s\n",
			SSL_error_func_string(SSL_errno));
		fprintf(stderr,"error is   :%s\n",
			SSL_error_string(SSL_errno));
		SSL_free(con2);
		close(s);
		exit(1);
		}
	width=s+1;
	printf("CIPHER is %s\n",SSL_get_cipher(con2));

	for (;;)
		{
		FD_ZERO(&readfds);
		FD_SET(fileno(stdin),&readfds);
		FD_SET(s,&readfds);
		select(width,&readfds,NULL,NULL,NULL);
		if (FD_ISSET(fileno(stdin),&readfds))
			{
			i=read(fileno(stdin),buf,BUFSIZZ);
			if ((i <= 0) || (buf[0] == 'Q'))
				{
				fprintf(stderr,"DONE\n");
				close(s);
				exit(0);
				}
			SSL_write(con2,buf,i);
			}
		if (FD_ISSET(s,&readfds))
			{
			i=SSL_read(con2,buf,BUFSIZZ);
			if (i<=0)
				{
				fprintf(stderr,"DONE\n");
				break;
				}
			write(fileno(stdout),buf,i);
			}
		}
	return(0);
	}

int init_client(server,sock,service,port)
char *server;
int *sock;
char *service;
int port;
	{
	struct servent ser;
	struct servent *serv;
	struct sockaddr_in them;
	struct hostent *host;
	struct protoent *prot;
	u_long ip_them;
	int s,i;

	if ((serv=getservbyname(service,PROTO)) == NULL)
		{
		serv= &ser;
		ser.s_port=port;
		}

	host=gethostbyname(server);
	if (host == NULL)
		{
		int a,b,c,d;

		if (sscanf(server,"%d.%d.%d.%d",&a,&b,&c,&d) == 4)
			ip_them=(a<<24)|(b<<16)|(c<<8)|d;
		else
			{
			fprintf(stderr,"unable to get %s's ip address\n",
				server);
			return(0);
			}
		}
	else
		memcpy(&ip_them,host->h_addr_list[0],sizeof(ip_them));
	memset((char *)&them,0,sizeof(them));
	them.sin_family=AF_INET;
	them.sin_port=serv->s_port;
	them.sin_addr.s_addr=ip_them;

	prot=getprotobyname("tcp");
	if (prot == NULL)
		{
		fprintf(stderr,"unable to find tcp protocol number");
		return(0);
		}
	s=socket(AF_INET,SOCK_STREAM,prot->p_proto);
	if (s == -1) { fprintf(stderr,"socket:%m"); return(0); }

/*	ling.l_onoff=1;
	ling.l_linger=0;
	i=setsockopt(s,SOL_SOCKET,SO_LINGER,(char *)&ling,sizeof(ling));
	if (i < 0) { fprintf(stderr,"linger:%m"); exit(0); } /**/
	i=0;
	i=setsockopt(s,SOL_SOCKET,SO_KEEPALIVE,(char *)&i,sizeof(i));
	if (i < 0) { fprintf(stderr,"keepalive:%m"); exit(0); }

	if (connect(s,(struct sockaddr *)&them,sizeof(them)) == -1)
		{
		close(s);
		perror("conn");
		fprintf(stderr,"connect:%m");
		return(0);
		}
	*sock=s;
	return(1);
	}

